const AbstractInstance = require("./abstractInstance")

class Instance extends AbstractInstance {
	constructor(db) {
		super(db)
		this.updates = {
			0: async () => {
				await this.db.run(`
create table if not exists bot (
	version int
)
		`).then(async () => {
					await this.db.all("select * from bot").then(async rows => {
						if(rows.length === 0) {
							await this.db.run("insert into bot (version) values (0)")
						}
					})
				})
			}
		}
	}

	get() {
		return this.db.get(`select * from bot`)
	}

	update(update) {
		return this.db.run(`update bot set ${this.getUpdateString(update)}`, update)
	}
}

module.exports = Instance
