const AbstractInstance = require("./abstractInstance")

class Instance extends AbstractInstance {
    constructor(db) {
        super(db)
        this.updates = {
            2: () => this.db.run(`
create table if not exists categoryRole (
	categoryId text not null,
	roleId text not null,
	
	primary key(categoryId, roleId)
)
				`),
            3: async () => {
                await this.create("728334680306352190", "727116447989497866")
            },
            4: async () => {
                await this.create("728334429369532428", "726835758542880800") //GD
                await this.create("728334429369532428", "726871073920122962") //LD/UX
                await this.create("728334614564831364", "726140165734793216") //prog
                await this.create("728334720722796575", "726140280478236704") //art
                await this.create("728334752716816589", "726141709028819024") //scenar
                await this.create("728334773600125018", "726140349361422337") //son
            }
        }
    }

    gets() {
        return this.db.all("select * from categoryRole")
    }

    getsByCategory(categoryId) {
        return this.db.all(`select * from categoryRole where categoryId = ?`, categoryId)
    }

    getsByRole(roleId) {
        return this.db.all(`select * from categoryRole where roleId = ?`, roleId)
    }

    get(categoryId, roleId) {
        return this.db.get(`select * from categoryRole where categoryId = ? and roleId = ?`, roleId)
    }

    create(categoryId, roleId) {
        if(!categoryId || !roleId) {
            throw new Error("one param is undefined")
        }
        return this.db.run(`insert into categoryRole(categoryId, roleId) values (?, ?)`, categoryId, roleId)
    }

    delete(categoryId, roleId) {
        return this.db.run(`delete from categoryRole where categoryId = ? and roleId = ?`, categoryId, roleId)
    }
}

module.exports = Instance
